%global pesign_vre 0.106-1
%global gnuefi_vre 1:3.0.5-6
%global openssl_vre 1.0.2j

%global debug_package %{nil}
%global __debug_package 1
%global _binaries_in_noarch_packages_terminate_build 0
%global __debug_install_post %{SOURCE100} x64 ia32
%undefine _debuginfo_subpackages

%global efidir redhat
%global shimrootdir %{_datadir}/shim/
%global shimversiondir %{shimrootdir}/%{version}-%{release}
%global efiarch x64
%global shimdir %{shimversiondir}/%{efiarch}
%global efialtarch ia32
%global shimaltdir %{shimversiondir}/%{efialtarch}

Name:		shim-unsigned-%{efiarch}
Version:	15.3
Release:	1.0.3%{?dist}
Summary:	First-stage UEFI bootloader
ExclusiveArch:	x86_64
License:	BSD
URL:		https://github.com/rhboot/shim
Source0:	https://github.com/rhboot/shim/releases/download/%{version}/shim-%{version}.tar.bz2
Source1:	gnu-efi-193ae1aeacd940ec3b48cc52f135f0695648a5f4.tar.bz2
# currently here's what's in our dbx:
# nothing.
Source2:	dbx.esl
Source3:	vendor_db.esl
Source4:	sbat.oracle.csv

Source100:	shim-find-debuginfo.sh

Patch0001:	0001-Check-if-r-flag-is-supported-for-dos2unix.patch
Patch0002:	0002-Move-the-check-for-the-SBAT-variable-properties-to-i.patch
Patch0003:	0003-Fix-SBAT-variable-content-validation.patch
Patch0004:	0004-Change-SBAT-variable-name-to-SbatLevel.patch
Patch0005:	0005-fallback-find_boot_option-needs-to-return-the-index.patch

BuildRequires:	dos2unix
BuildRequires:	elfutils-libelf-devel
BuildRequires:	git openssl-devel openssl
BuildRequires:	pesign >= %{pesign_vre}

# Shim uses OpenSSL, but cannot use the system copy as the UEFI ABI is not
# compatible with SysV (there's no red zone under UEFI) and there isn't a
# POSIX-style C library.
# BuildRequires:	OpenSSL
Provides:	bundled(openssl) = %{openssl_vre}

%global desc \
Initial UEFI bootloader that handles chaining to a trusted full \
bootloader under secure boot environments.
%global debug_desc \
This package provides debug information for package %{expand:%%{name}} \
Debug information is useful when developing applications that \
use this package or when debugging this package.

%description
%desc

%package -n shim-unsigned-%{efialtarch}
Summary:	First-stage UEFI bootloader (unsigned data)
Provides:	bundled(openssl) = %{openssl_vre}

%description -n shim-unsigned-%{efialtarch}
%desc

%package debuginfo
Summary:	Debug information for shim-unsigned-%{efiarch}
Requires:	%{name}-debugsource = %{version}-%{release}
Group:		Development/Debug
AutoReqProv:	0
BuildArch:	noarch

%description debuginfo
%debug_desc

%package -n shim-unsigned-%{efialtarch}-debuginfo
Summary:	Debug information for shim-unsigned-%{efialtarch}
Group:		Development/Debug
Requires:	%{name}-debugsource = %{version}-%{release}
AutoReqProv:	0
BuildArch:	noarch

%description -n shim-unsigned-%{efialtarch}-debuginfo
%debug_desc

%package debugsource
Summary:	Debug Source for shim-unsigned
Group:		Development/Debug
AutoReqProv:	0
BuildArch:	noarch

%description debugsource
%debug_desc

%prep
%setup -T -n %{name}-%{version}-%{release} -c
%{__tar} -xo -f %{SOURCE0}
mv shim-%{version} build-%{efiarch}
cd build-%{efiarch}
%{__tar} -xo -f %{SOURCE1} -C ./gnu-efi/
cp %{SOURCE4} ./data/
git init
git config user.email "example@example.com"
git config user.name "rpmbuild -bp"
git add .
git commit -a -q -m "%{version} baseline."
git am --ignore-whitespace %{patches} </dev/null
git config --unset user.email
git config --unset user.name

%ifarch x86_64
cd ..
%{__tar} -xo -f %{SOURCE0}
mv shim-%{version} build-%{efialtarch}
cd build-%{efialtarch}
%{__tar} -xo -f %{SOURCE1} -C ./gnu-efi/
cp %{SOURCE4} ./data/
git init
git config user.email "example@example.com"
git config user.name "rpmbuild -bp"
git add .
git commit -a -q -m "%{version} baseline."
git am --ignore-whitespace %{patches} </dev/null
git config --unset user.email
git config --unset user.name
%endif

%build
COMMIT_ID=$(cat build-%{efiarch}/commit)
MAKEFLAGS="RELEASE=%{release} COMMIT_ID=${COMMIT_ID} "
MAKEFLAGS+="EFIDIR=redhat PKGNAME=shim "
MAKEFLAGS+="ENABLE_SHIM_HASH=true "
MAKEFLAGS+="%{_smp_mflags}"

if [ -f "%{SOURCE2}" ]; then
	MAKEFLAGS="$MAKEFLAGS VENDOR_DBX_FILE=%{SOURCE2}"
fi
if [ -f "%{SOURCE3}" ]; then
	MAKEFLAGS="$MAKEFLAGS VENDOR_DB_FILE=%{SOURCE3}"
fi
cd build-%{efiarch}
make ${MAKEFLAGS} DEFAULT_LOADER='\\\\grub%{efiarch}.efi' all

%ifarch x86_64
cd ../build-%{efialtarch}
setarch linux32 make ${MAKEFLAGS} ARCH=ia32 'DEFAULT_LOADER=\\\\grubia32.efi' all
cd ../build-%{efiarch}
%endif

%install
COMMIT_ID=$(cat build-%{efiarch}/commit)
MAKEFLAGS+="EFIDIR=redhat PKGNAME=shim RELEASE=%{release} "
MAKEFLAGS+="ENABLE_SHIM_HASH=true "
MAKEFLAGS+="%{_smp_mflags}"
if [ -f "%{SOURCE2}" ]; then
	MAKEFLAGS="$MAKEFLAGS VENDOR_DBX_FILE=%{SOURCE2}"
fi
if [ -f "%{SOURCE3}" ]; then
	MAKEFLAGS="$MAKEFLAGS VENDOR_DB_FILE=%{SOURCE3}"
fi
cd build-%{efiarch}
make ${MAKEFLAGS} \
	DEFAULT_LOADER='\\\\grub%{efiarch}.efi' \
	DESTDIR=${RPM_BUILD_ROOT} \
	install-as-data install-debuginfo install-debugsource
cp COPYRIGHT ../
%ifarch x86_64
cd ../build-%{efialtarch}
setarch linux32 make ${MAKEFLAGS} \
	ARCH=ia32 'DEFAULT_LOADER=\\\\grubia32.efi' \
	DESTDIR=${RPM_BUILD_ROOT} \
	install-as-data install-debuginfo install-debugsource
cd ..
%endif

%files
%license COPYRIGHT
%dir %{shimrootdir}
%dir %{shimversiondir}
%dir %{shimdir}
%{shimdir}/*.efi
%{shimdir}/*.hash

%files -n shim-unsigned-%{efialtarch}
%license COPYRIGHT
%dir %{shimrootdir}
%dir %{shimversiondir}
%dir %{shimaltdir}
%{shimaltdir}/*.efi
%{shimaltdir}/*.hash

%files debuginfo -f build-%{efiarch}/debugfiles.list

%files -n shim-unsigned-%{efialtarch}-debuginfo -f build-%{efialtarch}/debugfiles.list

%files debugsource -f build-%{efiarch}/debugsource.list

%changelog
* Wed Aug 11 2021 Jan Setje-Eilers <jan.setjeeilers@oracle.com> - 15.3-1.0.3
- Pull in upstream fix for fallback regression [Orabug: 33216012]

* Sun Mar 28 2021 Alex Burmashev <alexander.burmashev@oracle.com> - 15.3-1.0.2
- Backport upstream SBAT fixes [Orabug: 32670000]

* Wed Mar 24 2021 Alex Burmashev <alexander.burmashev@oracle.com> - 15.3-1.0.1
- Update to upstream 15.3 [Orabug: 32670000]
- Update vendor EFI Signature List [Orabug: 32670000]
- Remove vendor certificates [Orabug: 32670000]
- Use bundled gnu-efi [Orabug: 32670000]
- Fix dos2unix [Orabug: 32670000]

* Fri Jul 10 2020 Alex Burmashev <alexander.burmashev@oracle.com> - 15-2.0.4
- Sync patchset between distro releases
- add vendor_db functionality
- update Oracle certificates

* Tue Nov 5 2019 Natalya Naumova <natalya.naumova@oracle.com> - 15-2.0.3
- bumping release

* Mon Aug 26 2019 Alex Burmashev <alexander.burmashev@oracle.com> - 15-2.0.2
- Fix booting shim from an EFI shell using a relative path [Orabug: 30227823]

* Fri May 17 2019 Alex Burmashev <alexander.burmashev@oracle.com> - 15-2.0.1
- Build shim binaries without timestamps [Orabug: 29793968]
- Remove call to TPM2 get_event_log(), update README.tpm [Orabug: 29793968]
- Replace certificate with Oracle Corporate one
- Use redhat as efidir name

* Tue May 7 2019 Fabian Arrotin <arrfab@centos.org> - 15-2.centos
- Rolled in CentOS CA for secureboot
- Added 0005-MokListRT-Fatal.patch to avoid crashing legacy uefi/non SB machines

* Tue Feb 12 2019 Peter Jones <pjones@redhat.com> - 15-2
- Fix MoK mirroring issue which breaks kdump without intervention
  Related: rhbz#1668966

* Fri Jul 20 2018 Peter Jones <pjones@redhat.com> - 15-1
- Update to shim 15

* Tue Sep 19 2017 Peter Jones <pjones@redhat.com> - 13-3
- Actually update to the *real* 13 final.
  Related: rhbz#1489604

* Thu Aug 31 2017 Peter Jones <pjones@redhat.com> - 13-2
- Actually update to 13 final.

* Fri Aug 18 2017 Peter Jones <pjones@redhat.com> - 13-1
- Make a new shim-unsigned-x64 package like the shim-unsigned-aarch64 one.
- This will (eventually) supersede what's in the "shim" package so we can
  make "shim" hold the signed one, which will confuse fewer people.
